"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
let AuthorizeGuard = class AuthorizeGuard {
    constructor(reflector) {
        this.reflector = reflector;
    }
    canActivate(context) {
        var _a, _b;
        const roles = this.reflector.get('roles', context.getHandler());
        const permissions = this.reflector.get('permissions', context.getHandler());
        if (!roles && !permissions) {
            return true;
        }
        if (((_a = roles) === null || _a === void 0 ? void 0 : _a.length) === 0 || ((_b = permissions) === null || _b === void 0 ? void 0 : _b.length) === 0) {
            return true;
        }
        const user = context.switchToHttp().getRequest().user;
        if (user) {
            let hasRole = () => true;
            let hasPermissions = () => true;
            if (roles && user.roles) {
                hasRole = () => {
                    return user.roles.some((role) => {
                        return roles.includes(role);
                    });
                };
            }
            if (permissions && user.permissions) {
                hasPermissions = () => {
                    return user.permissions.every((permission) => {
                        return permissions.includes(permission);
                    });
                };
            }
            return hasRole() && hasPermissions();
        }
        return false;
    }
};
AuthorizeGuard = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [core_1.Reflector])
], AuthorizeGuard);
exports.AuthorizeGuard = AuthorizeGuard;
